diff --git a/src/diff.c b/src/diff.c
index bb2344fc..ed1922b9 100644
--- a/src/diff.c
+++ b/src/diff.c
@@ -272,12 +272,10 @@ diff_common_read(struct view *view, const char *data, struct diff_state *state)
 		const int len = STRING_SIZE("diff --");
 
 		state->after_diff = true;
-		if (!strncmp(data + len, "combined ", strlen("combined ")) ||
-		    !strncmp(data + len, "cc ", strlen("cc ")))
-			state->combined_diff = true;
 		state->reading_diff_chunk = false;
 
 	} else if (type == LINE_DIFF_CHUNK) {
+		state->combined_diff = (strstr(data, "@@@") == data);
 		const int len = state->combined_diff ? STRING_SIZE("@@@") : STRING_SIZE("@@");
 		const char *context = strstr(data + len, state->combined_diff ? "@@@" : "@@");
 		struct line *line =
@@ -296,6 +294,8 @@ diff_common_read(struct view *view, const char *data, struct diff_state *state)
 		return true;
 
 	} else if (type == LINE_PP_MERGE) {
+		/* we will check again when highlighting diff chunks but we
+		 * want to highlight the diff stat before that */
 		state->combined_diff = true;
 
 	} else if (type == LINE_COMMIT) {
